/****************************************************************************
**
** Copyright (C) 2007-2008 Trolltech ASA. All rights reserved.
**
** This file is part of the QGtkStyle project on Trolltech Labs.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "gtksymbols_p.h"
#include <qdebug.h>
#include <X11/Xlib.h>

static bool displayDepth   =  -1;

static GtkWidget *gtkNotebook = 0;
static GtkWidget *gtkEntry = 0;
static GtkWidget *hScaleWidget = 0;
static GtkWidget *vScaleWidget = 0;
static GtkWidget *gtkProgressBar = 0;
static GtkWidget *gtkComboBox = 0;
static GtkWidget *gtkHScrollBar = 0;
static GtkWidget *gtkVScrollBar = 0;
static GtkWidget *gtkButton = 0;
static GtkWidget *gtkCheckButton = 0;
static GtkWidget *gtkSpinButton = 0;
static GtkWidget *gtkToolbar = 0;
static GtkWidget *gtkMenuItem = 0;
static GtkWidget *gtkMenubarItem = 0;
static GtkWidget *gtkMenubar = 0;
static GtkWidget *gtkMenu = 0;
static GtkWidget *gtkTreeView = 0;
static GtkWidget *gtkTreeHeader = 0;
static GtkWidget *gtkMenuSeparator = 0;
static GtkWidget *gtkCheckMenuItem = 0;
static GtkWidget *gtkFrame = 0;
static GtkWidget *gtkComboBoxEntry = 0;
static GtkWidget *gtkComboBoxEntryButton = 0;
static GtkWidget *gtkWindow = 0;

Ptr_gtk_container_forall p_gtk_container_forall = 0;
Ptr_gtk_init p_gtk_init = 0;
Ptr_gtk_style_attach p_gtk_style_attach = 0;
Ptr_gtk_window_new p_gtk_window_new = 0;
Ptr_gtk_widget_destroy p_gtk_widget_destroy = 0;
Ptr_gtk_widget_realize p_gtk_widget_realize = 0;
Ptr_gtk_menu_item_new p_gtk_menu_item_new = 0;
Ptr_gtk_check_menu_item_new p_gtk_check_menu_item_new = 0;
Ptr_gtk_menu_bar_new p_gtk_menu_bar_new = 0;
Ptr_gtk_menu_new p_gtk_menu_new = 0;
Ptr_gtk_button_new p_gtk_button_new = 0;
Ptr_gtk_check_button_new p_gtk_check_button_new = 0;
Ptr_gtk_spin_button_new p_gtk_spin_button_new = 0;
Ptr_gtk_frame_new p_gtk_frame_new = 0;
Ptr_gtk_entry_new p_gtk_entry_new = 0;
Ptr_gtk_hscale_new p_gtk_hscale_new = 0;
Ptr_gtk_vscale_new p_gtk_vscale_new = 0;
Ptr_gtk_hscrollbar_new p_gtk_hscrollbar_new = 0;
Ptr_gtk_vscrollbar_new p_gtk_vscrollbar_new = 0;
Ptr_gtk_notebook_new p_gtk_notebook_new = 0;
Ptr_gtk_toolbar_new p_gtk_toolbar_new = 0;
Ptr_gtk_tree_view_new p_gtk_tree_view_new = 0;
Ptr_gtk_combo_box_new p_gtk_combo_box_new = 0;
Ptr_gtk_combo_box_entry_new p_gtk_combo_box_entry_new = 0;
Ptr_gtk_progress_bar_new p_gtk_progress_bar_new = 0;
Ptr_gtk_container_add p_gtk_container_add = 0;
Ptr_gtk_menu_shell_append p_gtk_menu_shell_append = 0;
Ptr_gtk_range_set_adjustment p_gtk_range_set_adjustment = 0; 
Ptr_gtk_range_set_inverted p_gtk_range_set_inverted = 0; 
Ptr_gtk_icon_factory_lookup_default p_gtk_icon_factory_lookup_default = 0; 
Ptr_gtk_widget_style_get p_gtk_widget_style_get = 0;
Ptr_gtk_icon_set_render_icon p_gtk_icon_set_render_icon = 0;
Ptr_gtk_fixed_new p_gtk_fixed_new = 0;
Ptr_gtk_tree_view_column_new p_gtk_tree_view_column_new = 0;
Ptr_gtk_tree_view_append_column p_gtk_tree_view_append_column = 0;
Ptr_gtk_paint_check p_gtk_paint_check = 0;
Ptr_gtk_paint_box p_gtk_paint_box = 0;
Ptr_gtk_paint_flat_box p_gtk_paint_flat_box = 0;
Ptr_gtk_paint_option p_gtk_paint_option = 0;
Ptr_gtk_paint_box_gap p_gtk_paint_box_gap = 0;
Ptr_gtk_paint_extension p_gtk_paint_extension = 0;
Ptr_gtk_paint_slider p_gtk_paint_slider = 0;
Ptr_gtk_paint_shadow p_gtk_paint_shadow = 0;
Ptr_gtk_paint_resize_grip p_gtk_paint_resize_grip = 0;
Ptr_gtk_paint_focus p_gtk_paint_focus = 0;
Ptr_gtk_paint_arrow p_gtk_paint_arrow = 0;
Ptr_gtk_paint_handle p_gtk_paint_handle = 0;
Ptr_gtk_paint_expander p_gtk_paint_expander = 0;
Ptr_gtk_adjustment_new p_gtk_adjustment_new = 0;
Ptr_gtk_paint_hline p_gtk_paint_hline = 0;
Ptr_gtk_menu_item_set_submenu p_gtk_menu_item_set_submenu = 0;
Ptr_gtk_settings_get_default p_gtk_settings_get_default = 0;
Ptr_gtk_separator_menu_item_new p_gtk_separator_menu_item_new = 0;

Ptr_g_type_init p_g_type_init = 0;
Ptr_gconf_client_get_default p_gconf_client_get_default = 0;
Ptr_gconf_client_get_string p_gconf_client_get_string = 0;
Ptr_g_object_unref p_g_object_unref = 0;
Ptr_g_error_free p_g_error_free = 0;
Ptr_g_free p_g_free = 0;    

void resolveGtk()
{
    p_gtk_init = (Ptr_gtk_init)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_init");
    p_gtk_window_new = (Ptr_gtk_window_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_window_new");
    p_gtk_style_attach = (Ptr_gtk_style_attach)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_style_attach");
    p_gtk_widget_destroy = (Ptr_gtk_widget_destroy)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_widget_destroy");
    p_gtk_widget_realize = (Ptr_gtk_widget_realize)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_widget_realize");
    p_gtk_menu_item_new = (Ptr_gtk_menu_item_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_menu_item_new");
    p_gtk_check_menu_item_new = (Ptr_gtk_check_menu_item_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_check_menu_item_new");
    p_gtk_menu_bar_new = (Ptr_gtk_menu_bar_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_menu_bar_new");
    p_gtk_menu_new = (Ptr_gtk_menu_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_menu_new");
    p_gtk_toolbar_new = (Ptr_gtk_toolbar_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_toolbar_new");
    p_gtk_button_new = (Ptr_gtk_button_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_button_new");
    p_gtk_check_button_new = (Ptr_gtk_check_button_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_check_button_new");
    p_gtk_notebook_new = (Ptr_gtk_notebook_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_notebook_new");
    p_gtk_progress_bar_new = (Ptr_gtk_progress_bar_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_progress_bar_new");
    p_gtk_spin_button_new = (Ptr_gtk_spin_button_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_spin_button_new");
    p_gtk_hscale_new = (Ptr_gtk_hscale_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_hscale_new");
    p_gtk_vscale_new = (Ptr_gtk_vscale_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_vscale_new");
    p_gtk_hscrollbar_new = (Ptr_gtk_hscrollbar_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_hscrollbar_new");
    p_gtk_vscrollbar_new = (Ptr_gtk_vscrollbar_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_vscrollbar_new");
    p_gtk_menu_shell_append = (Ptr_gtk_menu_shell_append)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_menu_shell_append");
    p_gtk_entry_new = (Ptr_gtk_entry_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_entry_new");
    p_gtk_tree_view_new = (Ptr_gtk_tree_view_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_tree_view_new");
    p_gtk_combo_box_new = (Ptr_gtk_combo_box_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_combo_box_new");
    p_gtk_range_set_adjustment = (Ptr_gtk_range_set_adjustment)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_range_set_adjustment");
    p_gtk_range_set_inverted = (Ptr_gtk_range_set_inverted)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_range_set_inverted");
    p_gtk_container_add = (Ptr_gtk_container_add)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_container_add");
    p_gtk_icon_factory_lookup_default = (Ptr_gtk_icon_factory_lookup_default)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_icon_factory_lookup_default");
    p_gtk_widget_style_get = (Ptr_gtk_widget_style_get)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_widget_style_get");
    p_gtk_icon_set_render_icon = (Ptr_gtk_icon_set_render_icon)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_icon_set_render_icon");
    p_gtk_fixed_new = (Ptr_gtk_fixed_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_fixed_new");
    p_gtk_tree_view_column_new = (Ptr_gtk_tree_view_column_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_tree_view_column_new");
    p_gtk_tree_view_append_column = (Ptr_gtk_tree_view_append_column)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_tree_view_append_column");
    p_gtk_paint_check = (Ptr_gtk_paint_check)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_check");
    p_gtk_paint_box = (Ptr_gtk_paint_box)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_box");
    p_gtk_paint_flat_box = (Ptr_gtk_paint_flat_box)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_flat_box");
    p_gtk_paint_check = (Ptr_gtk_paint_check)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_check");
    p_gtk_paint_box = (Ptr_gtk_paint_box)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_box");
    p_gtk_paint_resize_grip = (Ptr_gtk_paint_resize_grip)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_resize_grip");
    p_gtk_paint_focus = (Ptr_gtk_paint_focus)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_focus");
    p_gtk_paint_shadow = (Ptr_gtk_paint_shadow)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_shadow");
    p_gtk_paint_slider = (Ptr_gtk_paint_slider)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_slider");
    p_gtk_paint_expander = (Ptr_gtk_paint_expander)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_expander");
    p_gtk_paint_handle = (Ptr_gtk_paint_handle)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_handle");
    p_gtk_paint_option = (Ptr_gtk_paint_option)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_option");
    p_gtk_paint_arrow = (Ptr_gtk_paint_arrow)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_arrow");
    p_gtk_paint_box_gap = (Ptr_gtk_paint_box_gap)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_box_gap");
    p_gtk_paint_extension = (Ptr_gtk_paint_extension)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_extension");
    p_gtk_paint_hline = (Ptr_gtk_paint_hline)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_paint_hline");
    p_gtk_adjustment_new = (Ptr_gtk_adjustment_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_adjustment_new");
    p_gtk_menu_item_set_submenu = (Ptr_gtk_menu_item_set_submenu)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_menu_item_set_submenu");
    p_gtk_settings_get_default = (Ptr_gtk_settings_get_default)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_settings_get_default");
    p_gtk_separator_menu_item_new = (Ptr_gtk_separator_menu_item_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_separator_menu_item_new");
    p_gtk_frame_new = (Ptr_gtk_frame_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_frame_new");
    p_gtk_combo_box_entry_new = (Ptr_gtk_combo_box_entry_new)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_combo_box_entry_new");
    p_gtk_container_forall = (Ptr_gtk_container_forall)QLibrary::resolve(QLatin1String("gtk-x11-2.0"), 0, "gtk_container_forall");
}

bool resolveGConf()
{
    if (!p_gconf_client_get_default) {
        p_g_type_init =              (Ptr_g_type_init)QLibrary::resolve(QLatin1String("gobject-2.0"), 0, "g_type_init");
        p_gconf_client_get_default = (Ptr_gconf_client_get_default)QLibrary::resolve(QLatin1String("gconf-2"), 4, "gconf_client_get_default");
        p_gconf_client_get_string =  (Ptr_gconf_client_get_string)QLibrary::resolve(QLatin1String("gconf-2"), 4, "gconf_client_get_string");
        p_g_object_unref =           (Ptr_g_object_unref)QLibrary::resolve(QLatin1String("gobject-2.0"), 0, "g_object_unref");
        p_g_error_free =             (Ptr_g_error_free)QLibrary::resolve(QLatin1String("glib-2.0"), 0, "g_error_free");
        p_g_free =                   (Ptr_g_free)QLibrary::resolve(QLatin1String("glib-2.0"), 0, "g_free");
    }
    return (p_gconf_client_get_default !=0);
}

typedef int (*x11ErrorHandler)(Display*, XErrorEvent*);

void cleanup_gtk_widgets()
{
    GTK_STYLE_CLEANUP(gtkNotebook);
    GTK_STYLE_CLEANUP(gtkEntry);
    GTK_STYLE_CLEANUP(hScaleWidget);
    GTK_STYLE_CLEANUP(vScaleWidget);
    GTK_STYLE_CLEANUP(gtkProgressBar);
    GTK_STYLE_CLEANUP(gtkComboBox);
    GTK_STYLE_CLEANUP(gtkHScrollBar);
    GTK_STYLE_CLEANUP(gtkVScrollBar);
    GTK_STYLE_CLEANUP(gtkButton);
    GTK_STYLE_CLEANUP(gtkCheckButton);
    GTK_STYLE_CLEANUP(gtkSpinButton);
    GTK_STYLE_CLEANUP(gtkToolbar);
    GTK_STYLE_CLEANUP(gtkTreeView);
    GTK_STYLE_CLEANUP(gtkMenuSeparator);
    GTK_STYLE_CLEANUP(gtkCheckMenuItem);
    GTK_STYLE_CLEANUP(gtkFrame);
    GTK_STYLE_CLEANUP(gtkComboBoxEntry);
    GTK_STYLE_CLEANUP(gtkMenu);
    GTK_STYLE_CLEANUP(gtkMenubar);
    GTK_STYLE_CLEANUP(gtkWindow); 
}

QString getGConfString(const QString value)
{
    QString retVal;
    if (resolveGConf()) {
        p_g_type_init();
        GConfClient* client = p_gconf_client_get_default();
        GError *err = 0;
        char *str = p_gconf_client_get_string(client, qPrintable(value), &err);
        if (!err) {
            retVal = QString::fromUtf8(str);
            p_g_free(str);
        }
        p_g_object_unref(client);
        if (err)
            p_g_error_free (err);
    }
    return retVal;
}

QString getThemeName()
{
    QString themeName;
    if (resolveGConf())
        themeName = getGConfString("/desktop/gnome/interface/gtk_theme");
    return themeName;
}

GtkStyle *getGtkStyle()
{
    GtkWidget *gtkWindow = get_gtk_window();
    if (gtkWindow) {
        if (displayDepth == -1)
            displayDepth = gdk_drawable_get_depth(gtkWindow->window);
        return gtkWindow->style;
    }
    return 0;
}

GtkWidget *get_gtk_window()
{
    static QString themeName;
    if (!gtkWindow && themeName.isEmpty()) {
        themeName = getThemeName();
        // Due to namespace conflicts with Qt3, we cannot
        // support the GTK_Qt Gtk engine as it would essentially
        // crash.
        if (themeName != "Qt") {
            resolveGtk();
            if (p_gtk_init) {
                x11ErrorHandler qt_x_errhandler = XSetErrorHandler(0);
                p_gtk_init (NULL, NULL);
                XSetErrorHandler(qt_x_errhandler);
                gtkWindow = p_gtk_window_new(GTK_WINDOW_POPUP);
                p_gtk_widget_realize(gtkWindow);
            } else {
                qWarning("QGtkStyle could not resolve GTK. Make sure you have installed the proper libraries.");
            }
        } else {
            qWarning("QGtkStyle cannot be used together with the GTK_Qt engine.");
        }
    }
    return gtkWindow;
}

void get_combobox_button(GtkWidget *widget, gpointer)
{
    if (GTK_IS_TOGGLE_BUTTON(widget)) {
        gtkComboBoxEntryButton = widget;
        p_gtk_widget_realize(gtkComboBoxEntryButton);
    }
}

void setup_gtk_widget(GtkWidget* widget)
{
    Q_ASSERT(widget);
    static GtkWidget* protoLayout = 0;
    if (!protoLayout) {
        protoLayout = p_gtk_fixed_new();
        p_gtk_container_add((GtkContainer*)(gtkWindow), protoLayout);
    }
    Q_ASSERT(protoLayout);
    p_gtk_container_add((GtkContainer*)(protoLayout), widget);
    p_gtk_widget_realize(widget);
}

GtkWidget *get_gtk_treeview()
{
    if (!gtkTreeView) {
        GtkTreeViewColumn* treeViewColumn;
        gtkTreeView = p_gtk_tree_view_new();
        setup_gtk_widget(gtkTreeView);
        treeViewColumn = p_gtk_tree_view_column_new();
        p_gtk_tree_view_append_column((GtkTreeView*)(gtkTreeView), treeViewColumn);
        gtkTreeHeader = treeViewColumn->button;
    }
    return gtkTreeView;
}

GtkWidget *get_gtk_tree_header()
{
    get_gtk_treeview(); // will create the tree header
    return gtkTreeHeader;
}

GtkWidget* get_gtk_combobox_entry()
{
    if (!gtkComboBoxEntry) {
        gtkComboBoxEntry = p_gtk_combo_box_entry_new();
        setup_gtk_widget(gtkComboBoxEntry);
        p_gtk_container_forall(GTK_CONTAINER(gtkComboBoxEntry), get_combobox_button, NULL);
    }
    return gtkComboBoxEntry;
}

GtkWidget* get_gtk_combobox_entry_button()
{
    get_gtk_combobox_entry(); // Will implicitly create the gtkComboBoxEntryButton
    return gtkComboBoxEntryButton;
}

GtkWidget* get_gtk_button()
{
    if (!gtkButton) {
        gtkButton = p_gtk_button_new();
        setup_gtk_widget(gtkButton);
    }
    return gtkButton;
}

GtkWidget* get_gtk_check_button()
{
    if (!gtkCheckButton) {
        gtkCheckButton = p_gtk_check_button_new();
        setup_gtk_widget(gtkCheckButton);
    }
    return gtkCheckButton;
}

GtkWidget* get_gtk_combobox()
{
    if (!gtkComboBox) {
        gtkComboBox = p_gtk_combo_box_new();
        setup_gtk_widget(gtkComboBox);
    }
    return gtkComboBox;
}

GtkWidget* get_gtk_toolbar()
{
    if (!gtkToolbar) {
        gtkToolbar = p_gtk_toolbar_new();
        setup_gtk_widget(gtkToolbar);
    }
    return gtkToolbar;
}

GtkWidget* get_gtk_menubar()
{
    if (!gtkMenubar) {
        gtkMenubar = p_gtk_menu_bar_new();
        setup_gtk_widget(gtkMenubar);
    }
    return gtkMenubar;
}

GtkWidget* get_gtk_menubaritem()
{
    if (!gtkMenubarItem) {
        get_gtk_menubar();
        gtkMenubarItem = p_gtk_menu_item_new();
        p_gtk_menu_shell_append((GtkMenuShell*)(gtkMenubar), gtkMenubarItem );
        p_gtk_widget_realize(gtkMenubarItem);
    }
    return gtkMenubarItem;
}

GtkWidget* get_gtk_menu()
{
    if (!gtkMenu) {
        get_gtk_menubaritem();
        gtkMenu = p_gtk_menu_new();
        p_gtk_menu_item_set_submenu(GTK_MENU_ITEM(gtkMenubarItem), gtkMenu);
        p_gtk_widget_realize(gtkMenu);
    }
    return gtkMenu;
}

GtkWidget* get_gtk_menuitem()
{
    if (!gtkMenuItem) {
        get_gtk_menu();
        gtkMenuItem = p_gtk_menu_item_new();
        p_gtk_container_add ((GtkContainer*)(gtkMenu), gtkMenuItem);
        p_gtk_widget_realize(gtkMenuItem);
    }
    return gtkMenuItem;
}

GtkWidget* get_gtk_menuseparator()
{
    if (!gtkMenuSeparator) {
        get_gtk_menu();
        gtkMenuSeparator = p_gtk_separator_menu_item_new();
        p_gtk_container_add ((GtkContainer*)(gtkMenu), gtkMenuSeparator);
        p_gtk_widget_realize(gtkMenuSeparator);
    }
    return gtkMenuSeparator;
}

GtkWidget* get_gtk_check_menuitem()
{
    if (!gtkCheckMenuItem) {
        get_gtk_menu();
        gtkCheckMenuItem = p_gtk_check_menu_item_new();
        p_gtk_container_add ((GtkContainer*)(gtkMenu), gtkCheckMenuItem);
        p_gtk_widget_realize(gtkCheckMenuItem);
    }
    return gtkCheckMenuItem;
}


GtkWidget* get_gtk_spinbutton()
{
    if (!gtkSpinButton) {
        gtkSpinButton = p_gtk_spin_button_new((GtkAdjustment*)(p_gtk_adjustment_new (1, 0, 1, 0, 0, 0)), 0.1, 3);
        setup_gtk_widget(gtkSpinButton);
    }
    return gtkSpinButton;
}

GtkWidget* get_gtk_frame()
{
    if (!gtkFrame) {
        gtkFrame = p_gtk_frame_new();
        setup_gtk_widget(gtkFrame);
    }
    return gtkFrame;
}

GtkWidget* get_gtk_entry()
{
    if (!gtkEntry) {
        gtkEntry = p_gtk_entry_new();
        setup_gtk_widget(gtkEntry);
    }
    return gtkEntry;
}

GtkWidget* get_gtk_vscrollbar()
{
    if (!gtkVScrollBar) {
        gtkVScrollBar = p_gtk_vscrollbar_new(NULL);
        setup_gtk_widget(gtkVScrollBar);
    }
    return gtkVScrollBar;
}

GtkWidget* get_gtk_hscrollbar()
{
    if (!gtkHScrollBar) {
        Q_ASSERT(p_gtk_hscrollbar_new);
        gtkHScrollBar = p_gtk_hscrollbar_new(NULL);
        setup_gtk_widget(gtkHScrollBar);
    }
    return gtkHScrollBar;
}

GtkWidget* get_gtk_notebook()
{
    if (!gtkNotebook) {
        gtkNotebook = p_gtk_notebook_new();
        setup_gtk_widget(gtkNotebook);
    }
    return gtkNotebook;
}

GtkWidget* get_gtk_progressbar()
{
    if (!gtkProgressBar) {
        gtkProgressBar = p_gtk_progress_bar_new();
        setup_gtk_widget(gtkProgressBar);
    }
    return gtkProgressBar;
}

GtkWidget* get_gtk_hscale()
{
    if (!hScaleWidget) {
        hScaleWidget = p_gtk_hscale_new ((GtkAdjustment*)(p_gtk_adjustment_new (1, 0, 1, 0, 0, 0)));
        setup_gtk_widget(hScaleWidget);
    }
    return hScaleWidget;
}

GtkWidget* get_gtk_vscale()
{
    if (!vScaleWidget) {
        vScaleWidget = p_gtk_vscale_new ((GtkAdjustment*)(p_gtk_adjustment_new (1, 0, 1, 0, 0, 0)));
        setup_gtk_widget(vScaleWidget);
    }
    return vScaleWidget;
}

