/****************************************************************************
**
** Copyright (C) 2007-2008 Trolltech ASA. All rights reserved.
**
** This file is part of the QGtkStyle project on Trolltech Labs.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include <gtk/gtk.h>
#include <QLibrary>

#define GTK_STYLE_CLEANUP(widget) \
    if (widget) { \
        p_gtk_widget_destroy(widget); \
        widget = 0; \
    } \

extern "C" {
    void resolveGtk();
    bool resolveGConf();
    GtkWidget* get_gtk_window();
    GtkWidget* get_gtk_treeview();
    GtkWidget* get_gtk_tree_header();
    GtkWidget* get_gtk_combobox_entry();
    GtkWidget* get_gtk_combobox_entry_button();
    GtkWidget* get_gtk_button();
    GtkWidget* get_gtk_check_button();
    GtkWidget* get_gtk_combobox();
    GtkWidget* get_gtk_menuseparator();
    GtkWidget* get_gtk_menubar();
    GtkWidget* get_gtk_menubaritem();
    GtkWidget* get_gtk_menu();
    GtkWidget* get_gtk_menuitem();
    GtkWidget* get_gtk_menuseparator();
    GtkWidget* get_gtk_notebook();;
    GtkWidget* get_gtk_spinbutton();
    GtkWidget* get_gtk_frame();
    GtkWidget* get_gtk_entry();
    GtkWidget* get_gtk_hscrollbar();
    GtkWidget* get_gtk_vscrollbar();
    GtkWidget* get_gtk_notebook();
    GtkWidget* get_gtk_vscale();
    GtkWidget* get_gtk_hscale();
    GtkWidget* get_gtk_progressbar();
    GtkWidget* get_gtk_toolbar();
    GtkWidget* get_gtk_check_menuitem();

    struct GConfClient;
    void cleanup_gtk_widgets();
    QString getGConfString(const QString value);
    GtkStyle *getGtkStyle();

    typedef void (*Ptr_g_type_init)();
    typedef GConfClient* (*Ptr_gconf_client_get_default)();
    typedef char* (*Ptr_gconf_client_get_string)(GConfClient*, const char*, GError **);
    typedef void (*Ptr_g_object_unref)(void *);
    typedef void (*Ptr_g_error_free)(GError *);
    typedef void (*Ptr_g_free)(void*);

    typedef void (*Ptr_gtk_init)(int *, char ***);
    typedef GtkWidget* (*Ptr_gtk_window_new) (GtkWindowType);
    typedef GtkStyle* (*Ptr_gtk_style_attach)(GtkStyle *, GdkWindow *);
    typedef void (*Ptr_gtk_widget_destroy) (GtkWidget *);
    typedef void (*Ptr_gtk_widget_realize) (GtkWidget *);
    typedef GtkWidget* (*Ptr_gtk_menu_item_new)(void);
    typedef GtkWidget* (*Ptr_gtk_separator_menu_item_new)(void);
    typedef GtkWidget* (*Ptr_gtk_check_menu_item_new)(void);
    typedef GtkWidget* (*Ptr_gtk_menu_bar_new)(void);
    typedef GtkWidget* (*Ptr_gtk_menu_new)(void);
    typedef GtkWidget* (*Ptr_gtk_combo_box_entry_new)(void);
    typedef GtkWidget* (*Ptr_gtk_toolbar_new)(void);
    typedef GtkWidget* (*Ptr_gtk_spin_button_new)(GtkAdjustment*, double, int);
    typedef GtkWidget* (*Ptr_gtk_button_new)(void);
    typedef GtkWidget* (*Ptr_gtk_check_button_new)(void);
    typedef GtkWidget* (*Ptr_gtk_notebook_new)(void);
    typedef GtkWidget* (*Ptr_gtk_progress_bar_new)(void);
    typedef GtkWidget* (*Ptr_gtk_hscale_new)(GtkAdjustment*);
    typedef GtkWidget* (*Ptr_gtk_vscale_new)(GtkAdjustment*);
    typedef GtkWidget* (*Ptr_gtk_hscrollbar_new)(GtkAdjustment*);
    typedef GtkWidget* (*Ptr_gtk_vscrollbar_new)(GtkAdjustment*);
    typedef void       (*Ptr_gtk_menu_shell_append)(GtkMenuShell *, GtkWidget *); 
    typedef GtkWidget* (*Ptr_gtk_entry_new)(void);
    typedef GtkWidget* (*Ptr_gtk_tree_view_new)(void);
    typedef GtkWidget* (*Ptr_gtk_combo_box_new)(void);
    typedef GtkWidget* (*Ptr_gtk_frame_new)(void);
    typedef GtkSettings* (*Ptr_gtk_settings_get_default)(void);
    typedef void (*Ptr_gtk_range_set_adjustment)(GtkRange *, GtkAdjustment *); 
    typedef void (*Ptr_gtk_range_set_inverted)(GtkRange*, bool);
    typedef void (*Ptr_gtk_container_add)(GtkContainer *container, GtkWidget *widget);
    typedef GtkIconSet* (*Ptr_gtk_icon_factory_lookup_default) (const gchar*);
    typedef void (*Ptr_gtk_widget_style_get)(GtkWidget *, const gchar *first_property_name, ...);
    typedef GtkWidget* (*Ptr_gtk_combo_box_new)(void);
    typedef GtkTreeViewColumn* (*Ptr_gtk_tree_view_column_new)(void);
    typedef GtkWidget* (*Ptr_gtk_fixed_new)(void);
    typedef GdkPixbuf* (*Ptr_gtk_icon_set_render_icon)(GtkIconSet *, GtkStyle *, GtkTextDirection, GtkStateType, GtkIconSize, GtkWidget *,const char *);
    typedef void (*Ptr_gtk_tree_view_append_column) (GtkTreeView*, GtkTreeViewColumn*);
    typedef void  (*Ptr_gtk_paint_check) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , gint , gint);
    typedef void  (*Ptr_gtk_paint_box) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , gint , gint);
    typedef void  (*Ptr_gtk_paint_resize_grip) (GtkStyle*,GdkWindow*, GtkStateType, const GdkRectangle *, GtkWidget *, const gchar *, GdkWindowEdge, gint , gint , gint , gint);
    typedef void  (*Ptr_gtk_paint_focus) (GtkStyle*,GdkWindow*, GtkStateType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , gint , gint);
    typedef void  (*Ptr_gtk_paint_shadow) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , gint , gint);
    typedef void  (*Ptr_gtk_paint_slider) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , gint , gint, GtkOrientation);
    typedef void  (*Ptr_gtk_paint_expander) (GtkStyle*,GdkWindow*, GtkStateType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , GtkExpanderStyle );
    typedef void  (*Ptr_gtk_paint_handle) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , gint , gint, GtkOrientation);
    typedef void  (*Ptr_gtk_paint_arrow) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, GtkArrowType, gboolean, gint , gint , gint , gint);
    typedef void  (*Ptr_gtk_paint_option) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , gint , gint);
    typedef void  (*Ptr_gtk_paint_flat_box) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint , gint , gint , gint);
    typedef void  (*Ptr_gtk_paint_box_gap) (GtkStyle*,GdkWindow*, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint, gint, gint , gint, GtkPositionType, gint gap_x, gint gap_width);
    typedef void (*Ptr_gtk_paint_extension) (GtkStyle *, GdkWindow *, GtkStateType, GtkShadowType, const GdkRectangle *, GtkWidget *, const gchar *, gint, gint, gint, gint, GtkPositionType);
    typedef GtkObject* (*Ptr_gtk_adjustment_new) (double, double, double, double, double, double);
    typedef void   (*Ptr_gtk_paint_hline) (GtkStyle *, GdkWindow *, GtkStateType, const GdkRectangle *, GtkWidget *, const gchar *, gint, gint, gint y);
    typedef void (*Ptr_gtk_menu_item_set_submenu) (GtkMenuItem *, GtkWidget *);
    typedef void (*Ptr_gtk_container_forall) (GtkContainer *, GtkCallback, gpointer);

    extern Ptr_gtk_container_forall p_gtk_container_forall;
    extern Ptr_gtk_init p_gtk_init;
    extern Ptr_gtk_style_attach p_gtk_style_attach;
    extern Ptr_gtk_window_new p_gtk_window_new;
    extern Ptr_gtk_widget_destroy p_gtk_widget_destroy;
    extern Ptr_gtk_widget_realize p_gtk_widget_realize;
    extern Ptr_gtk_menu_item_new p_gtk_menu_item_new;
    extern Ptr_gtk_check_menu_item_new p_gtk_check_menu_item_new;
    extern Ptr_gtk_menu_bar_new p_gtk_menu_bar_new;
    extern Ptr_gtk_menu_new p_gtk_menu_new;
    extern Ptr_gtk_button_new p_gtk_button_new;
    extern Ptr_gtk_check_button_new p_gtk_check_button_new;
    extern Ptr_gtk_spin_button_new p_gtk_spin_button_new;
    extern Ptr_gtk_frame_new p_gtk_frame_new;
    extern Ptr_gtk_entry_new p_gtk_entry_new;
    extern Ptr_gtk_hscale_new p_gtk_hscale_new;
    extern Ptr_gtk_vscale_new p_gtk_vscale_new;
    extern Ptr_gtk_hscrollbar_new p_gtk_hscrollbar_new;
    extern Ptr_gtk_vscrollbar_new p_gtk_vscrollbar_new;
    extern Ptr_gtk_notebook_new p_gtk_notebook_new;
    extern Ptr_gtk_toolbar_new p_gtk_toolbar_new;
    extern Ptr_gtk_tree_view_new p_gtk_tree_view_new;
    extern Ptr_gtk_combo_box_new p_gtk_combo_box_new;
    extern Ptr_gtk_combo_box_entry_new p_gtk_combo_box_entry_new;
    extern Ptr_gtk_progress_bar_new p_gtk_progress_bar_new;
    extern Ptr_gtk_container_add p_gtk_container_add;
    extern Ptr_gtk_menu_shell_append p_gtk_menu_shell_append;
    extern Ptr_gtk_range_set_adjustment p_gtk_range_set_adjustment; 
    extern Ptr_gtk_range_set_inverted p_gtk_range_set_inverted; 
    extern Ptr_gtk_icon_factory_lookup_default p_gtk_icon_factory_lookup_default; 
    extern Ptr_gtk_widget_style_get p_gtk_widget_style_get;
    extern Ptr_gtk_icon_set_render_icon p_gtk_icon_set_render_icon;
    extern Ptr_gtk_fixed_new p_gtk_fixed_new;
    extern Ptr_gtk_tree_view_column_new p_gtk_tree_view_column_new;
    extern Ptr_gtk_tree_view_append_column p_gtk_tree_view_append_column;
    extern Ptr_gtk_paint_check p_gtk_paint_check;
    extern Ptr_gtk_paint_box p_gtk_paint_box;
    extern Ptr_gtk_paint_flat_box p_gtk_paint_flat_box;
    extern Ptr_gtk_paint_option p_gtk_paint_option;
    extern Ptr_gtk_paint_box_gap p_gtk_paint_box_gap;
    extern Ptr_gtk_paint_extension p_gtk_paint_extension;
    extern Ptr_gtk_paint_slider p_gtk_paint_slider;
    extern Ptr_gtk_paint_shadow p_gtk_paint_shadow;
    extern Ptr_gtk_paint_resize_grip p_gtk_paint_resize_grip;
    extern Ptr_gtk_paint_focus p_gtk_paint_focus;
    extern Ptr_gtk_paint_arrow p_gtk_paint_arrow;
    extern Ptr_gtk_paint_handle p_gtk_paint_handle;
    extern Ptr_gtk_paint_expander p_gtk_paint_expander;
    extern Ptr_gtk_adjustment_new p_gtk_adjustment_new;
    extern Ptr_gtk_paint_hline p_gtk_paint_hline;
    extern Ptr_gtk_menu_item_set_submenu p_gtk_menu_item_set_submenu;
    extern Ptr_gtk_settings_get_default p_gtk_settings_get_default;
    extern Ptr_gtk_separator_menu_item_new p_gtk_separator_menu_item_new;

    extern Ptr_g_type_init p_g_type_init;
    extern Ptr_gconf_client_get_default p_gconf_client_get_default;
    extern Ptr_gconf_client_get_string p_gconf_client_get_string;
    extern Ptr_g_object_unref p_g_object_unref;
    extern Ptr_g_error_free p_g_error_free;
    extern Ptr_g_free p_g_free; 
}

